(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular-dynaform/core'), require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('@angular/material'), require('@angular/platform-browser/animations'), require('rxjs/operators'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@angular-dynaform/material', ['exports', '@angular-dynaform/core', '@angular/common', '@angular/core', '@angular/forms', '@angular/material', '@angular/platform-browser/animations', 'rxjs/operators', 'rxjs'], factory) :
    (global = global || self, factory((global.adf = global.adf || {}, global.adf.material = {}), global.adf.core, global.ng.common, global.ng.core, global.ng.forms, global.ng.material, global.ng.platformBrowser.animations, global.Rx.Observable.prototype, global.Rx));
}(this, function (exports, core, common, core$1, forms, material, animations, operators, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var MaterialArrayComponent = (function (_super) {
        __extends(MaterialArrayComponent, _super);
        function MaterialArrayComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialArrayComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-array-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <fieldset [id]=\"model.id\" [ngClass]=\"model.css.control\" adfHTMLDomElement>\n        <legend\n          *ngIf=\"model.local.label\"\n          [ngClass]=\"model.css.label\"\n          [innerHTML]=\"model.local.label\"\n        ></legend>\n        <ng-container *ngIf=\"model.header\">\n          <div [ngClass]=\"model.header?.css.content\">\n            <ng-container\n              *ngFor=\"let item of model.header?.items\"\n              adfControlComponent\n              [model]=\"item\"\n            ></ng-container>\n          </div>\n        </ng-container>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <div [formArrayName]=\"model.key\" [ngClass]=\"model.css.content\">\n          <ng-container *ngFor=\"let arrayItem of model.items; let i = index\" [formGroupName]=\"i\">\n            <div [ngClass]=\"arrayItem.css.content\">\n              <ng-container\n                *ngFor=\"let item of arrayItem.items\"\n                adfControlComponent\n                [model]=\"item\"\n              ></ng-container>\n            </div>\n          </ng-container>\n        </div>\n        <ng-container *ngIf=\"model.footer\">\n          <div [ngClass]=\"model.footer?.css.content\">\n            <ng-container\n              *ngFor=\"let item of model.footer?.items\"\n              adfControlComponent\n              [model]=\"item\"\n            ></ng-container>\n          </div>\n        </ng-container>\n      </fieldset>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialArrayComponent }]
                    }] }
        ];
        return MaterialArrayComponent;
    }(core.DynamicFormControlComponent));

    var MaterialButtonComponent = (function (_super) {
        __extends(MaterialButtonComponent, _super);
        function MaterialButtonComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialButtonComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            _super.prototype.ngAfterViewInit.call(this);
            setTimeout((function () {
                if (_this.model.ngControl.disabled) {
                    _this.model.ngControl.enable({ emitEvent: false });
                    _this.model.ngControl.disable();
                }
                else {
                    _this.model.ngControl.disable({ emitEvent: false });
                    _this.model.ngControl.enable();
                }
            }));
        };
        MaterialButtonComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-button-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <button\n        mat-raised-button\n        [formControlName]=\"model.key\"\n        [id]=\"model.id\"\n        [ngClass]=\"model.css.control\"\n        [type]=\"buttonType\"\n        adfHTMLDomElement\n        ngDefaultControl\n      >\n        <span [ngClass]=\"model.css.control\" [innerHTML]=\"model.local.label\"></span>\n      </button>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialButtonComponent }]
                    }] }
        ];
        return MaterialButtonComponent;
    }(core.DynamicFormControlComponent));

    var MaterialCheckboxComponent = (function (_super) {
        __extends(MaterialCheckboxComponent, _super);
        function MaterialCheckboxComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialCheckboxComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-checkbox-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <mat-checkbox\n        [formControlName]=\"model.key\"\n        [id]=\"model.id\"\n        [ngClass]=\"model.css.control\"\n        adfHTMLDomElement\n        [required]=\"options.required ? '' : null\"\n      >\n        {{ model.local.label }}\n      </mat-checkbox>\n      <adf-error-container [model]=\"model\"></adf-error-container>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialCheckboxComponent }]
                    }] }
        ];
        return MaterialCheckboxComponent;
    }(core.DynamicFormControlComponent));

    var MaterialDatepickerComponent = (function (_super) {
        __extends(MaterialDatepickerComponent, _super);
        function MaterialDatepickerComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialDatepickerComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-datepicker-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <label\n        *ngIf=\"model.local.label\"\n        [attr.for]=\"model.id\"\n        class=\"adf-front-label\"\n        [ngClass]=\"model.css.label\"\n        [innerHTML]=\"model.local.label\"\n      ></label>\n      <mat-form-field [ngClass]=\"model.css.control\">\n        <input\n          matInput\n          [formControlName]=\"model.key\"\n          [id]=\"model.id\"\n          type=\"text\"\n          [readonly]=\"options.readOnly\"\n          [maxlength]=\"options.maxLength\"\n          [placeholder]=\"model.local.placeholder\"\n          [ngClass]=\"model.css.control\"\n          adfHTMLDomElement\n          [matDatepicker]=\"myDatepicker\"\n          [required]=\"options.required ? '' : null\"\n        />\n        <mat-datepicker-toggle matSuffix [for]=\"myDatepicker\"></mat-datepicker-toggle>\n        <mat-datepicker #myDatepicker></mat-datepicker>\n        <span matPrefix *ngIf=\"options.icon\">\n          <mat-icon>{{ options.icon }}</mat-icon>\n        </span>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <mat-hint [innerHTML]=\"model.local.hint\"></mat-hint>\n      </mat-form-field>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [
                            { provide: core.DynamicFormControlComponentBase, useExisting: MaterialDatepickerComponent },
                        ]
                    }] }
        ];
        return MaterialDatepickerComponent;
    }(core.DynamicFormControlComponent));

    var MaterialDivisionComponent = (function (_super) {
        __extends(MaterialDivisionComponent, _super);
        function MaterialDivisionComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialDivisionComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-division-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <div [ngClass]=\"model.css.control\" adfHTMLDomElement>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <div [ngClass]=\"model.css.content\">\n          <ng-container\n            *ngFor=\"let item of model.items\"\n            adfControlComponent\n            [model]=\"item\"\n          ></ng-container>\n        </div>\n      </div>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialDivisionComponent }]
                    }] }
        ];
        return MaterialDivisionComponent;
    }(core.DynamicFormControlComponent));

    var MaterialErrorComponent = (function (_super) {
        __extends(MaterialErrorComponent, _super);
        function MaterialErrorComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialErrorComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-error-component',
                        template: "\n    <mat-error [ngClass]=\"model.css.error\" [innerHTML]=\"error?.message\"></mat-error>\n  ",
                        inputs: ['model', 'error'],
                        host: { class: 'mat-input-error' },
                        providers: [{ provide: core.DynamicFormErrorComponent, useExisting: MaterialErrorComponent }]
                    }] }
        ];
        return MaterialErrorComponent;
    }(core.DynamicFormErrorComponent));

    var MaterialFieldsetComponent = (function (_super) {
        __extends(MaterialFieldsetComponent, _super);
        function MaterialFieldsetComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialFieldsetComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-fieldset-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <fieldset [id]=\"model.id\" [ngClass]=\"model.css.control\" adfHTMLDomElement>\n        <legend\n          *ngIf=\"model.local.label\"\n          [ngClass]=\"model.css.label\"\n          [innerHTML]=\"model.local.label\"\n        ></legend>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <div [ngClass]=\"model.css.content\">\n          <ng-container\n            *ngFor=\"let item of model.items\"\n            adfControlComponent\n            [model]=\"item\"\n          ></ng-container>\n        </div>\n      </fieldset>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialFieldsetComponent }]
                    }] }
        ];
        return MaterialFieldsetComponent;
    }(core.DynamicFormControlComponent));

    var MaterialFormComponent = (function (_super) {
        __extends(MaterialFormComponent, _super);
        function MaterialFormComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialFormComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-form-component',
                        template: "\n    <div>\n      <form\n        [formGroup]=\"model.ngControl\"\n        [id]=\"model.id\"\n        [ngClass]=\"model.css.control\"\n        (ngSubmit)=\"onSubmit($event)\"\n        (reset)=\"onReset($event)\"\n        adfHTMLDomElement\n        novalidate\n      >\n        <div [ngClass]=\"model.css.content\">\n          <ng-container\n            *ngFor=\"let item of model.items\"\n            adfControlComponent\n            [model]=\"item\"\n          ></ng-container>\n        </div>\n      </form>\n    </div>\n  ",
                        inputs: ['model'],
                        outputs: ['submit', 'reset'],
                        providers: [
                            {
                                provide: core.DynamicFormControlComponentBase,
                                useExisting: MaterialFormComponent,
                            },
                            { provide: core.DynamicFormFormControlComponent, useExisting: MaterialFormComponent },
                        ]
                    }] }
        ];
        return MaterialFormComponent;
    }(core.DynamicFormFormControlComponent));

    var MaterialInputComponent = (function (_super) {
        __extends(MaterialInputComponent, _super);
        function MaterialInputComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialInputComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-input-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <label\n        *ngIf=\"model.local.label\"\n        [attr.for]=\"model.id\"\n        class=\"adf-front-label\"\n        [ngClass]=\"model.css.label\"\n        [innerHTML]=\"model.local.label\"\n      ></label>\n      <mat-form-field [ngClass]=\"model.css.control\">\n        <input\n          matInput\n          [formControlName]=\"model.key\"\n          [id]=\"model.id\"\n          [type]=\"options.inputType || 'text'\"\n          [readonly]=\"options.readOnly\"\n          [attr.autocomplete]=\"model.autoComplete\"\n          [placeholder]=\"model.local.placeholder\"\n          [ngClass]=\"model.css.control\"\n          adfHTMLDomElement\n          [required]=\"options.required ? '' : null\"\n          [attr.min]=\"options.min\"\n          [attr.max]=\"options.max\"\n          [maxlength]=\"options.maxLength\"\n        />\n        <span matPrefix *ngIf=\"options.icon\">\n          <mat-icon>{{ options.icon }}</mat-icon>\n        </span>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <mat-hint [innerHTML]=\"model.local.hint\"></mat-hint>\n      </mat-form-field>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialInputComponent }]
                    }] }
        ];
        return MaterialInputComponent;
    }(core.DynamicFormControlComponent));

    var MaterialRadioGroupComponent = (function (_super) {
        __extends(MaterialRadioGroupComponent, _super);
        function MaterialRadioGroupComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialRadioGroupComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-radiogroup-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <label\n        *ngIf=\"model.local.label\"\n        [attr.for]=\"model.id\"\n        class=\"adf-front-label\"\n        [ngClass]=\"model.css.label\"\n        [innerHTML]=\"model.local.label\"\n      ></label>\n      <mat-radio-group\n        [id]=\"model.id\"\n        [formControlName]=\"model.key\"\n        ngDefaultControl\n        adfHTMLDomElement\n        [ngClass]=\"model.css.control\"\n        [required]=\"options.required ? '' : null\"\n      >\n        <mat-radio-button *ngFor=\"let opt of model.local.valueOptions\" [value]=\"opt.value\">\n          <span [innerHTML]=\"opt.label\"></span>\n        </mat-radio-button>\n      </mat-radio-group>\n      <adf-error-container [model]=\"model\"></adf-error-container>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [
                            { provide: core.DynamicFormControlComponentBase, useExisting: MaterialRadioGroupComponent },
                        ]
                    }] }
        ];
        return MaterialRadioGroupComponent;
    }(core.DynamicFormControlComponent));

    var MaterialSelectComponent = (function (_super) {
        __extends(MaterialSelectComponent, _super);
        function MaterialSelectComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialSelectComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-select-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <label\n        *ngIf=\"model.local.label\"\n        [attr.for]=\"model.id\"\n        class=\"adf-front-label\"\n        [ngClass]=\"model.css.label\"\n        [innerHTML]=\"model.local.label\"\n      ></label>\n      <mat-form-field [ngClass]=\"model.css.control\">\n        <mat-select\n          [formControlName]=\"model.key\"\n          [id]=\"model.id\"\n          [placeholder]=\"model.local.placeholder\"\n          [multiple]=\"options.multiple\"\n          [ngClass]=\"model.css.control\"\n          adfHTMLDomElement\n          [required]=\"options.required ? '' : null\"\n        >\n          <mat-option *ngFor=\"let opt of model.local.valueOptions\" [value]=\"opt.value\">\n            <span [innerHTML]=\"opt.label\"></span>\n          </mat-option>\n        </mat-select>\n        <span matPrefix *ngIf=\"options.icon\">\n          <mat-icon>{{ options.icon }}</mat-icon>\n        </span>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <mat-hint [innerHTML]=\"model.local.hint\"></mat-hint>\n      </mat-form-field>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialSelectComponent }]
                    }] }
        ];
        return MaterialSelectComponent;
    }(core.DynamicFormControlComponent));

    var MaterialSeparatorComponent = (function (_super) {
        __extends(MaterialSeparatorComponent, _super);
        function MaterialSeparatorComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialSeparatorComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-separator-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <span [ngClass]=\"model.css.control\" [innerHTML]=\"model.local.label\"></span>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [
                            { provide: core.DynamicFormControlComponentBase, useExisting: MaterialSeparatorComponent },
                        ]
                    }] }
        ];
        return MaterialSeparatorComponent;
    }(core.DynamicFormControlComponent));

    var MaterialSliderComponent = (function (_super) {
        __extends(MaterialSliderComponent, _super);
        function MaterialSliderComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialSliderComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-slider-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <label\n        *ngIf=\"model.local.label\"\n        [attr.for]=\"model.id\"\n        class=\"adf-front-label\"\n        [ngClass]=\"model.css.label\"\n        [innerHTML]=\"model.local.label\"\n      ></label>\n      <mat-slider\n        [formControlName]=\"model.key\"\n        [id]=\"model.id\"\n        [step]=\"options.step\"\n        [ngClass]=\"model.css.control\"\n        adfHTMLDomElement\n        [required]=\"options.required ? '' : null\"\n        [attr.min]=\"options.min\"\n        [attr.max]=\"options.max\"\n      ></mat-slider>\n      <adf-error-container [model]=\"model\"></adf-error-container>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialSliderComponent }]
                    }] }
        ];
        return MaterialSliderComponent;
    }(core.DynamicFormControlComponent));

    var MaterialStepperComponent = (function (_super) {
        __extends(MaterialStepperComponent, _super);
        function MaterialStepperComponent(form, dynamicFormService, elRef) {
            return _super.call(this, form, dynamicFormService, elRef) || this;
        }
        MaterialStepperComponent.prototype.ngOnInit = function () {
            this.stepper = new MatStepperWrapper(this.matStepper);
            if (!this.form.stepper) {
                this.form.stepper = this.stepper;
            }
            _super.prototype.ngOnInit.call(this);
        };
        MaterialStepperComponent.prototype.ngAfterViewInit = function () {
            (((this.stepper))).matStepper = this.matStepper;
            _super.prototype.ngAfterViewInit.call(this);
        };
        MaterialStepperComponent.prototype.ngOnDestroy = function () {
            _super.prototype.ngOnDestroy.call(this);
            if (this.stepper) {
                if (this.form.stepper === this.stepper) {
                    this.form.stepper = undefined;
                }
                (((this.stepper))).matStepper = undefined;
            }
        };
        MaterialStepperComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-stepper-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <div [ngClass]=\"model.css.control\" adfHTMLDomElement>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n\n        <!--ng-template #steps>\n            <mat-step *ngFor=\"let item of model.items; let i=index\"\n              [stepControl]=\"item.ngSubsetControl ? item.ngSubsetControl : item.ngControl\"\n              [optional]=\"options.matStepOptional\" [editable]=\"options.matStepEditable\" [completed]=\"options.matStepCompleted\"\n            >\n              <ng-template matStepLabel>{{item.local.label}}</ng-template>\n              <ng-template adfControlComponent [model]=\"item\"></ng-template>\n            </mat-step>\n        </ng-template-->\n\n        <ng-container *ngIf=\"options.matStepperVertical; else horizontalStepper\">\n          <mat-vertical-stepper\n            [ngClass]=\"model.css.content\"\n            [linear]=\"options.matStepperLinear === undefined ? false : options.matStepperLinear\"\n            #stepper\n          >\n            <!--ng-container *ngTemplateOutlet=\"steps\"></ng-container-->\n            <mat-step\n              *ngFor=\"let item of model.items; let i = index\"\n              [stepControl]=\"item.ngSubsetControl ? item.ngSubsetControl : item.ngControl\"\n              [editable]=\"options.matStepEditable === undefined ? true : options.matStepEditable\"\n              [optional]=\"options.matStepOptional\"\n              [completed]=\"options.matStepCompleted\"\n            >\n              <ng-template matStepLabel>{{ item.local.label }}</ng-template>\n              <ng-template adfControlComponent [model]=\"item\"></ng-template>\n            </mat-step>\n          </mat-vertical-stepper>\n        </ng-container>\n\n        <ng-template #horizontalStepper>\n          <mat-horizontal-stepper\n            [ngClass]=\"model.css.content\"\n            [linear]=\"options.matStepperLinear === undefined ? false : options.matStepperLinear\"\n            #stepper\n          >\n            <!--ng-container *ngTemplateOutlet=\"steps\"></ng-container-->\n            <mat-step\n              *ngFor=\"let item of model.items; let i = index\"\n              [stepControl]=\"item.ngSubsetControl ? item.ngSubsetControl : item.ngControl\"\n              [editable]=\"options.matStepEditable === undefined ? true : options.matStepEditable\"\n              [optional]=\"options.matStepOptional\"\n              [completed]=\"options.matStepCompleted\"\n            >\n              <ng-template matStepLabel>{{ item.local.label }}</ng-template>\n              <ng-template adfControlComponent [model]=\"item\"></ng-template>\n            </mat-step>\n          </mat-horizontal-stepper>\n        </ng-template>\n      </div>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialStepperComponent }]
                    }] }
        ];
        MaterialStepperComponent.ctorParameters = function () { return [
            { type: core.DynamicForm },
            { type: core.DynamicFormService },
            { type: core$1.ElementRef }
        ]; };
        MaterialStepperComponent.propDecorators = {
            matStepper: [{ type: core$1.ViewChild, args: ['stepper', { static: true },] }]
        };
        return MaterialStepperComponent;
    }(core.DynamicFormControlComponent));
    var MatStepperWrapper = (function () {
        function MatStepperWrapper(matStepper) {
            this._selectionChange = new core$1.EventEmitter();
            this.matStepper = matStepper;
        }
        Object.defineProperty(MatStepperWrapper.prototype, "matStepper", {
            get: function () {
                return this._matStepper;
            },
            set: function (matStepper) {
                this.changeStepper(matStepper);
            },
            enumerable: true,
            configurable: true
        });
        MatStepperWrapper.prototype.prev = function () {
            if (this.matStepper) {
                this.matStepper.previous();
            }
        };
        MatStepperWrapper.prototype.next = function () {
            if (this.matStepper) {
                this.matStepper.next();
            }
        };
        MatStepperWrapper.prototype.selectionChange = function () {
            return this._selectionChange;
        };
        MatStepperWrapper.prototype.length = function () {
            return this.matStepper && this.matStepper._steps ? this.matStepper._steps.length : 0;
        };
        MatStepperWrapper.prototype.changeStepper = function (matStepper) {
            var _this = this;
            if (this._matStepper === matStepper) {
                return;
            }
            if (this._matStepper && this.unsubscribe) {
                this.unsubscribe.next();
                this.unsubscribe.complete();
            }
            if (matStepper) {
                this.unsubscribe = new rxjs.Subject();
                matStepper.selectionChange
                    .pipe(operators.map((function (sc) { return sc.selectedIndex; })))
                    .pipe(operators.takeUntil(this.unsubscribe))
                    .subscribe((function (currIndex) { return _this._selectionChange.emit(currIndex); }));
            }
            this._matStepper = matStepper;
        };
        return MatStepperWrapper;
    }());

    var MaterialSwitchComponent = (function (_super) {
        __extends(MaterialSwitchComponent, _super);
        function MaterialSwitchComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialSwitchComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-switch-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <label\n        *ngIf=\"model.local.label\"\n        [attr.for]=\"model.id\"\n        class=\"adf-front-label\"\n        [ngClass]=\"model.css.label\"\n        [innerHTML]=\"model.local.label\"\n      ></label>\n      <mat-slide-toggle\n        [formControlName]=\"model.key\"\n        [id]=\"model.id\"\n        [ngClass]=\"model.css.control\"\n        adfHTMLDomElement\n        [required]=\"options.required ? '' : null\"\n      ></mat-slide-toggle>\n      <adf-error-container [model]=\"model\"></adf-error-container>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialSwitchComponent }]
                    }] }
        ];
        return MaterialSwitchComponent;
    }(core.DynamicFormControlComponent));

    var MaterialTabGroupComponent = (function (_super) {
        __extends(MaterialTabGroupComponent, _super);
        function MaterialTabGroupComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialTabGroupComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-tab-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <div [ngClass]=\"model.css.control\" adfHTMLDomElement>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <mat-tab-group\n          adfHTMLDomElement\n          [ngClass]=\"model.css.content\"\n          [dynamicHeight]=\"options.matTabGroupDynamicHeight\"\n        >\n          <mat-tab *ngFor=\"let item of model.items\">\n            <ng-template mat-tab-label>{{ item.local.label }}</ng-template>\n            <ng-template adfControlComponent [model]=\"item\"></ng-template>\n          </mat-tab>\n        </mat-tab-group>\n      </div>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialTabGroupComponent }]
                    }] }
        ];
        return MaterialTabGroupComponent;
    }(core.DynamicFormControlComponent));

    var MaterialTextareaComponent = (function (_super) {
        __extends(MaterialTextareaComponent, _super);
        function MaterialTextareaComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MaterialTextareaComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'adf-material-textarea-component',
                        template: "\n    <div [formGroup]=\"model.ngGroup\" [hidden]=\"model.hidden\">\n      <label\n        *ngIf=\"model.local.label\"\n        [attr.for]=\"model.id\"\n        class=\"adf-front-label\"\n        [ngClass]=\"model.css.label\"\n        [innerHTML]=\"model.local.label\"\n      ></label>\n      <mat-form-field [ngClass]=\"model.css.control\">\n        <textarea\n          matInput\n          [formControlName]=\"model.key\"\n          [id]=\"model.id\"\n          [readonly]=\"options.readOnly\"\n          [wrap]=\"options.wrap\"\n          [cols]=\"options.cols\"\n          [rows]=\"options.rows\"\n          [placeholder]=\"model.local.placeholder\"\n          [ngClass]=\"model.css.control\"\n          adfHTMLDomElement\n          [required]=\"options.required ? '' : null\"\n          [attr.min]=\"options.min\"\n          [attr.max]=\"options.max\"\n          [maxlength]=\"options.maxLength\"\n        ></textarea>\n        <span matPrefix *ngIf=\"options.icon\">\n          <mat-icon>{{ options.icon }}</mat-icon>\n        </span>\n        <adf-error-container [model]=\"model\"></adf-error-container>\n        <mat-hint [innerHTML]=\"model.local.hint\"></mat-hint>\n      </mat-form-field>\n    </div>\n  ",
                        inputs: ['model'],
                        providers: [{ provide: core.DynamicFormControlComponentBase, useExisting: MaterialTextareaComponent }]
                    }] }
        ];
        return MaterialTextareaComponent;
    }(core.DynamicFormControlComponent));

    var MaterialControlType = {
        CONTROL_UNKNOWN: 'mat:unknown',
        CONTROL_DIVISION: 'mat:division',
        CONTROL_FIELDSET: 'mat:fieldset',
        CONTROL_TABGROUP: 'mat:tabgroup',
        CONTROL_STEPPER: 'mat:stepper',
        CONTROL_ARRAY: 'mat:array',
        CONTROL_CHECKBOX: 'mat:checkbox',
        CONTROL_INPUT: 'mat:input',
        CONTROL_RADIOGROUP: 'mat:radiogroup',
        CONTROL_SELECT: 'mat:select',
        CONTROL_SLIDER: 'mat:slider',
        CONTROL_SWITCH: 'mat:switch',
        CONTROL_TEXTAREA: 'mat:textarea',
        CONTROL_DATEPICKER: 'mat:datepicker',
        CONTROL_TIMEPICKER: 'mat:timepicker',
        CONTROL_LISTPICKER: 'mat:listpicker',
        CONTROL_UPLOAD: 'mat:upload',
        CONTROL_BUTTON: 'mat:button',
        CONTROL_SEPARATOR: 'mat:separator',
    };

    var entryComponents = [
        MaterialFormComponent,
        MaterialErrorComponent,
        MaterialArrayComponent,
        MaterialDivisionComponent,
        MaterialFieldsetComponent,
        MaterialButtonComponent,
        MaterialCheckboxComponent,
        MaterialInputComponent,
        MaterialRadioGroupComponent,
        MaterialSelectComponent,
        MaterialSeparatorComponent,
        MaterialSliderComponent,
        MaterialSwitchComponent,
        MaterialTextareaComponent,
        MaterialDatepickerComponent,
        MaterialTabGroupComponent,
        MaterialStepperComponent,
    ];
    var moduleDeclarations = entryComponents;
    var DynamicMaterialFormModule = (function () {
        function DynamicMaterialFormModule(dynamicFormService, parentModule) {
            this.dynamicFormService = dynamicFormService;
            if (parentModule) {
                return;
            }
            this.dynamicFormService.setFormControlComponent(MaterialFormComponent, true);
            this.dynamicFormService.setErrorComponent(MaterialErrorComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_ARRAY, MaterialArrayComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_FIELDSET, MaterialFieldsetComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_DIVISION, MaterialDivisionComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_TABGROUP, MaterialTabGroupComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_STEPPER, MaterialStepperComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_BUTTON, MaterialButtonComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_SEPARATOR, MaterialSeparatorComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_CHECKBOX, MaterialCheckboxComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_DATEPICKER, MaterialDatepickerComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_INPUT, MaterialInputComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_RADIOGROUP, MaterialRadioGroupComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_SELECT, MaterialSelectComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_SLIDER, MaterialSliderComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_SWITCH, MaterialSwitchComponent, true);
            this.dynamicFormService.setControlComponent(core.ControlType.CONTROL_TEXTAREA, MaterialTextareaComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_ARRAY, MaterialArrayComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_FIELDSET, MaterialFieldsetComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_DIVISION, MaterialDivisionComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_TABGROUP, MaterialTabGroupComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_STEPPER, MaterialStepperComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_BUTTON, MaterialButtonComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SEPARATOR, MaterialSeparatorComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_CHECKBOX, MaterialCheckboxComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_DATEPICKER, MaterialDatepickerComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_INPUT, MaterialInputComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_RADIOGROUP, MaterialRadioGroupComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SELECT, MaterialSelectComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SLIDER, MaterialSliderComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_SWITCH, MaterialSwitchComponent, true);
            this.dynamicFormService.setControlComponent(MaterialControlType.CONTROL_TEXTAREA, MaterialTextareaComponent, true);
        }
        DynamicMaterialFormModule.decorators = [
            { type: core$1.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            core.DynamicFormModule,
                            animations.BrowserAnimationsModule,
                            material.MatButtonModule,
                            material.MatCheckboxModule,
                            material.MatInputModule,
                            material.MatRadioModule,
                            material.MatSelectModule,
                            material.MatSliderModule,
                            material.MatSlideToggleModule,
                            material.MatNativeDateModule,
                            material.MatDatepickerModule,
                            material.MatTabsModule,
                            material.MatStepperModule,
                            material.MatIconModule,
                        ],
                        declarations: [moduleDeclarations],
                        entryComponents: entryComponents,
                        exports: [core.DynamicFormModule, entryComponents],
                    },] }
        ];
        DynamicMaterialFormModule.ctorParameters = function () { return [
            { type: core.DynamicFormService },
            { type: DynamicMaterialFormModule, decorators: [{ type: core$1.Optional }, { type: core$1.SkipSelf }] }
        ]; };
        return DynamicMaterialFormModule;
    }());

    exports.DynamicMaterialFormModule = DynamicMaterialFormModule;
    exports.MaterialArrayComponent = MaterialArrayComponent;
    exports.MaterialButtonComponent = MaterialButtonComponent;
    exports.MaterialCheckboxComponent = MaterialCheckboxComponent;
    exports.MaterialControlType = MaterialControlType;
    exports.MaterialDivisionComponent = MaterialDivisionComponent;
    exports.MaterialErrorComponent = MaterialErrorComponent;
    exports.MaterialFieldsetComponent = MaterialFieldsetComponent;
    exports.MaterialFormComponent = MaterialFormComponent;
    exports.MaterialInputComponent = MaterialInputComponent;
    exports.MaterialRadioGroupComponent = MaterialRadioGroupComponent;
    exports.MaterialSelectComponent = MaterialSelectComponent;
    exports.MaterialSeparatorComponent = MaterialSeparatorComponent;
    exports.MaterialSliderComponent = MaterialSliderComponent;
    exports.MaterialSwitchComponent = MaterialSwitchComponent;
    exports.MaterialTextareaComponent = MaterialTextareaComponent;
    exports.ɵa = MaterialDatepickerComponent;
    exports.ɵb = MaterialTabGroupComponent;
    exports.ɵc = MaterialStepperComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular-dynaform-material.umd.js.map
